FUNCTION myBackUp(pcRoot, pnGen, paFiles, pcModus)	&& RootName, pocet generaci, seznam souboru, BACKUP/RESTORE
*	tato verze pracuje s SAWzip
*	zatim pcModus neni pouzit, pouze BACKUP
*	paFiles muze obsahovat i masku souboru
external array paFiles
private all like x*

IF (pnGen < 1)
	RETURN [no backup required]
ENDIF
xcExt=[zip]
pcModus=iif(empty(pcModus), [B], Upper(left(pcModus, 1)) )

*	kontrola dostupnosti DLL
xcRegKey=[SAWZip.Archive.1]
xcDLLfile=FullPath([SAWzip.dll])
IF .not.myRegisterDLL(xcRegKey, xcDLLfile)
	RETURN [not registered ]+xcDLLfile
ENDIF
IF .not.file([Zlib.dll])
	RETURN [not available Zlib.dll]
ENDIF

pcRoot=FullPath(pcRoot)
*	kontrola existence BackUp Directory, zalozeni, pokud neexistuje
xcBackupDir=JustPath(pcRoot)
IF .not.Directory(xcBackupDir)
	MkDir (xcBackupDir)
ENDIF

pcRoot=AddBs(xcBackUpDir)+JustFname(pcRoot)
*	posunuti generaci archivu
FOR xnI=pnGen to 2 step -1
	xcF=ForceExt(pcRoot+[_]+Transform(xnI), xcExt)
	xcF_1=ForceExt(pcRoot+[_]+Transform(xnI-1), xcExt)
	erase (xcF)
	if file(xcF_1)
		rename (xcF_1) to (xcF)	
	endif
ENDFOR
*	ulozeni (komprimace) dat do _1
xcF_1=ForceExt(pcRoot+[_]+Transform(1), xcExt)
xoZIP=CreateObject(xcRegKey)
xoZIP.Create(xcF_1)			&& zalozeni noveho souboru archivu

FOR each xcMask in paFiles
	xnPocet=ADir(xaFiles, xcMask, "RSHA")
	xcMask=FullPath(xcMask)
	FOR xnI=1 to xnPocet
		xcS=FullPath(AddBs(JustPath(xcMask))+xaFiles[xnI, 1])
		If file(xcS)
			xoZip.Files.AddFileByName(xcS, 9, .T., .T.)	&& max.compress, fullpath, overwrite
		EndIf
	ENDFOR
ENDFOR
xoZip.Close()

RETURN []