FUNCTION GetNewTmp(pcMode)
EXTERNAL ARRAY aTmpFiles

*	generates unique name of TMP-file (sys3). The name will be saved in public array aTmpFiles
*	for deleting on Prg shutdown. ( GetNewTmp("Delete"): EraTmpFiles() )

private all like x*
xcNewTmp=""
IF empty(pcMode).or.(type("pcMode")#"C").or.(Upper(left(pcMode,1))#"D")
  if Type("aTmpFiles")=="U"               && seznam jeste neexistuje
    PUBLIC aTmpFiles[1]
  else
    dimension aTmpFiles[ALen(aTmpFiles, 1)+1]
  endif
  xcTemp=GetEnv("TEMP")
  Do while .T.
  	xcRandom=SUBSTR(SYS(2015), 3, 10)
    xcNewTmp=iif(Empty(xcTemp), xcRandom, AddBs(xcTemp)+xcRandom )
    if AScan(aTmpFiles, xcNewTmp) > 0
      loop
    endif
    aTmpFiles[ALen(aTmpFiles, 1)]=xcNewTmp
   exit
  EndDo
  
ELSE		&& zruseni TMP-souboru

  if Type("aTmpFiles") # "U"               && seznam TMP-files existuje
  	xcOnError=On([ERROR])
  	ON ERROR do AccessDenied
    For each xcTmpFile in aTmpFiles
      p_EraFil(xcTmpFile+".*")
    EndFor
    ON ERROR &xcOnError.
    release aTmpFiles
  endif

ENDIF
RETURN xcNewTmp

FUNCTION AccessDenied()
IF Error()<>1705		&& neni Access denied
	&xcOnError.			&& standardni errorhandler
ENDIF
RETURN .T.
